package inescID.crypto;

import javax.crypto.SecretKey;
import java.security.interfaces.RSAKey;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.util.FileTool;

public class FileEncryptionTool extends FileTool {
  EncryptionTool  encrypt_tool;

  public FileEncryptionTool() throws Exception {
    this.encrypt_tool = new EncryptionTool();
  }


  public void writeObject2File(String file, Object obj, SecretKey key) throws
      Exception {
   byte[] ciphered = encrypt_tool.EncryptTripleDES(obj, key);
   super.writeObject2File(file, ciphered);
  }

  public void writeObject2File(String file, Object obj, RSAKey key) throws
      Exception {
   MixCipherEnvelope ciphered = encrypt_tool.EncryptMixCipherMode(obj, key);
   super.writeObject2File(file, ciphered);
  }

  public Object readObjectFromFile(String file, SecretKey key) throws
      Exception {
    byte[] cipher = (byte[]) super.readObjectFromFile(file);
    byte[] decipher = this.encrypt_tool.DecryptTripleDES(cipher, key);
    Object obj = this.encrypt_tool.ByteArrayToObject(decipher);
    return obj;
   }

   public Object readObjectFromFile(String file, RSAKey key) throws
      Exception {
    MixCipherEnvelope envelope= (MixCipherEnvelope) super.readObjectFromFile(file);
    byte[] decipher = this.encrypt_tool.DecryptMixCipherMode(envelope, key);
    Object obj = this.encrypt_tool.ByteArrayToObject(decipher);
    return obj;
   }

}
