package inescID.crypto;

import java.security.Signature;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SignedObject;
import java.io.Serializable;
import java.security.NoSuchAlgorithmException;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class SigningTool {
  public static final String DEFAULT_SIGN_ALGORITHM = "SHA1withRSA";

  Signature sign;

  public SigningTool() throws NoSuchAlgorithmException {
     this.sign = Signature.getInstance(DEFAULT_SIGN_ALGORITHM);
 }


  public SigningTool(String algorithm) throws NoSuchAlgorithmException {
    this.sign = Signature.getInstance(algorithm);
  }

 public void initSign(PrivateKey key) throws java.
      security.NoSuchAlgorithmException,
      java.security.InvalidKeyException {
    this.sign.initSign(key);
  }

  public byte[] sign(byte[] msg) throws java.security.SignatureException
  {
    this.sign.update(msg);
    return this.sign.sign();
  }

  public SignedObject signObject(PrivateKey key, Serializable object) throws Exception {
    SignedObject so = new SignedObject(object, key, this.sign);
    return so;
  }

  public void initVerify(PublicKey key) throws java.
      security.NoSuchAlgorithmException,
      java.security.InvalidKeyException,
      java.security.SignatureException {
    this.initVerify(key, DEFAULT_SIGN_ALGORITHM);
  }

  public void initVerify(PublicKey key, String algorithm) throws java.
      security.NoSuchAlgorithmException,
      java.security.InvalidKeyException,
      java.security.SignatureException {
    this.sign = Signature.getInstance(algorithm);
    this.sign.initVerify(key);
  }

  public boolean verify(byte[] msg, byte[] signature) throws java.security.
      SignatureException {
    this.sign.update(msg);
    return this.sign.verify(signature);
  }

  public boolean verifyObject(PublicKey key, SignedObject object) throws Exception {
    return object.verify(key, this.sign);
  }

}
