package inescID.revs;

/**
 * <p>Title: revs</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import java.io.File;

public class REVSConfiguration {
  public static final int MAX_STRING_LENGTH = 100;
  public static final int MAX_COMMENT_LENGTH = 1024;
  public static final int MAX_SERVERS = 10;
  public static final int COMMITMENT_LEGTH = 20;//bytes

  public static final int DEFAULT_VOTES2FORWARD = 20;
  public static final int DEFAULT_FORWARD_INTERVAL = 60000; //ms

  public static final String CHARSET = "ISO-8859-1";

  public static final String CONFIGURATION_PATH = "conf" + File.separator;

  public static final String CONFIGURATION_FILE = CONFIGURATION_PATH + "server.cfg";
  public static final char[] DEFAULT_KEYSTORE_PASS = "REVSpass".toCharArray();
  public static final String TRUSTSTORE = CONFIGURATION_PATH + "tstore.ks";
  public static final String PRIVATE_KEYSTORE = CONFIGURATION_PATH + "kstore.ks";
  public static final String COMMISSIONER_CERT_FILE = CONFIGURATION_PATH + "commissioner.crt";

  public static final String WELCOME_MESSAGE_FILE = CONFIGURATION_PATH + "welcome.html";
  public static final String DISTRIBUTORS_FILE = CONFIGURATION_PATH + "distributors";

  public static final String DB_DEFAULT_USER = "sa";
  public static final String DB_DEFAULT_PASSWORD = "";

  public static final String MARKER = ";";


  public static final String ALIAS_SERVER_KEY = "server";

  public static final int DEFAULT_RSA_KEY_SIZE = 1024;
  public static final String RANDOM_ALGORITHM = "SHA1PRNG";
  public static final String RSA_ALGORITHM = "RSA";
  public static final String TRIPLE_DES = "DESede";

 // public static final String LOG = "log" + File.pathSeparator + "revs.log";

  public static final String DEFAULT_COMMISSIONER_ADDRESS = "//localhost/commissioner";
  public static final String DEFAULT_DISTRIBUTOR_ADDRESS = "//localhost/distributor";
  public static final String DEFAULT_ADMINISTRATOR_ADDRESS = "//localhost/administrator";
  public static final String DEFAULT_ANONYMIZER_ADDRESS = "//localhost/anonymizer";
  public static final String DEFAULT_COUNTER_ADDRESS = "//localhost/counter";

  public REVSConfiguration() {
  }
}
