package inescID.revs.commissioner;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class CreateVotersPasswords extends JDialog {
  JLabel title = new JLabel();
  JPanel jPanel1 = new JPanel();
  JRadioButton all_voters = new JRadioButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JRadioButton no_password_voters = new JRadioButton();
  JPanel jPanel2 = new JPanel();
  JPanel panel1 = new JPanel();
  JRadioButton just_password1 = new JRadioButton();
  GridBagLayout gridBagLayout3 = new GridBagLayout();
  JRadioButton password_pin = new JRadioButton();
  JPanel panel2 = new JPanel();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JPanel jPanel3 = new JPanel();
  JButton ok = new JButton();
  BoxLayout2 boxLayout21 = new BoxLayout2();
  Component component1;
  JPanel jPanel4 = new JPanel();
  JButton cancel = new JButton();
  ButtonGroup group_password_pin = new ButtonGroup();
  ButtonGroup group_voters = new ButtonGroup();

  public CreateVotersPasswords(Frame frame, String title, boolean modal, Commissioner commi) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
      this.setActionListener(commi);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public CreateVotersPasswords(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public CreateVotersPasswords() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    component1 = Box.createVerticalStrut(8);
    title.setText("Create Voters\' Passwords");
    title.setFont(new java.awt.Font("Dialog", 0, 18));
    title.setOpaque(false);
    title.setRequestFocusEnabled(true);
    all_voters.setText("All voters");
    no_password_voters.setSelected(true);
    no_password_voters.setText("Only for voters without passwords");
    jPanel2.setLayout(gridBagLayout2);
    panel1.setLayout(gridBagLayout1);
    panel1.setAlignmentX((float) 1.0);
    panel1.setAlignmentY((float) 0.5);
    panel1.setBorder(BorderFactory.createEtchedBorder());
    panel1.setPreferredSize(new Dimension(220, 50));
    just_password1.setSelected(true);
    just_password1.setText("Just Password");
    password_pin.setSelected(false);
    password_pin.setText("Password and PIN");
    panel2.setBorder(BorderFactory.createEtchedBorder());
    panel2.setMinimumSize(new Dimension(200, 50));
    panel2.setPreferredSize(new Dimension(220, 50));
    panel2.setLayout(gridBagLayout3);
    ok.setMaximumSize(new Dimension(65, 23));
    ok.setMinimumSize(new Dimension(65, 23));
    ok.setPreferredSize(new Dimension(65, 23));
    ok.setHorizontalAlignment(SwingConstants.CENTER);
    ok.setHorizontalTextPosition(SwingConstants.CENTER);
    ok.setText("OK");
    jPanel3.setMinimumSize(new Dimension(81, 50));
    jPanel3.setPreferredSize(new Dimension(81, 50));
    jPanel3.setLayout(boxLayout21);
    boxLayout21.setAxis(BoxLayout.Y_AXIS);
    cancel.setText("Cancel");
    this.setTitle("Create Voters\'s Passwords");
    jPanel3.add(component1, null);
    this.getContentPane().add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(title, null);
    this.getContentPane().add(jPanel2,  BorderLayout.CENTER);
    panel1.add(no_password_voters, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel1.add(all_voters, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    this.getContentPane().add(jPanel3,  BorderLayout.SOUTH);
    jPanel2.add(panel2,    new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 0, 0));
    panel2.add(password_pin,     new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(just_password1, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(panel1,   new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    jPanel3.add(jPanel4, null);
    jPanel4.add(ok, null);
    jPanel4.add(cancel, null);
    group_password_pin.add(password_pin);
    group_password_pin.add(just_password1);
    group_voters.add(no_password_voters);
    group_voters.add(all_voters);
  }

  void setActionListener(Commissioner commi){
    ok.addActionListener(new CreateVotersPasswords_ok_actionAdapter(commi));
    cancel.addActionListener(new CreateVotersPasswords_cancel_actionAdapter(commi));
  }

  public boolean allVoters(){
    return this.all_voters.isSelected();
  }

  public boolean passwordPin(){
    return this.password_pin.isSelected();
  }

}

class CreateVotersPasswords_ok_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  CreateVotersPasswords_ok_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.CVPok_actionPerformed(e);
  }
}

class CreateVotersPasswords_cancel_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  CreateVotersPasswords_cancel_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.CVPcancel_actionPerformed(e);
  }
}
