package inescID.revs.commissioner;

import javax.swing.*;
import java.awt.*;
import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */
import inescID.revs.util.*;
import java.awt.event.*;

public class FrameCommissioner extends JFrame {


  static UIManager.LookAndFeelInfo[] looks;

  Commissioner commi;
  JPanel current_panel;
  MainMenu main_menu;
  VoterAdministration voter_administration;
  GroupAdministration group_administration;
  SelectVoters select_voters;
  ElectionAdministration election_administration;
  ConfigurationAdministration configuration_administration;
  ConfigurationSelection configuration_selection;
  ServersAdministration server_administration;
  Utilities utilities;
 // SelectAdministrators select_administrators;
 // SelectCounters select_counters;
  VoterPassword voter_password;
  CreateVotersPasswords create_voters_passwords;

  BorderLayout borderLayout1 = new BorderLayout();
  JScrollPane jScrollPaneMessage = new JScrollPane();
  JTextArea message = new JTextArea();
  JLabel jLabel1 = new JLabel();
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuView = new JMenu();
  JMenu jMenuLook = new JMenu();
  JMenuItem jMenuItem1 = new JMenuItem();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuItemExit = new JMenuItem();



  public FrameCommissioner() {
    Commissioner aux = new Commissioner();
    init(aux);
  }

  public FrameCommissioner(Commissioner aux){
    init(aux);
  }

  public void init(Commissioner commissioner) {

    commi = commissioner;
    commi.setFrameCommissioner(this);

    main_menu = new MainMenu(commi);
    voter_administration = new VoterAdministration(commi);
    group_administration = new GroupAdministration(commi);
    select_voters = new SelectVoters(commi);

    election_administration = new ElectionAdministration(this, commi);
    configuration_administration = new ConfigurationAdministration(commi);
    server_administration = new ServersAdministration(commi);
    configuration_selection = new ConfigurationSelection(commi);
    utilities = new Utilities(commi);

    /*
    configuration_selection;
    select_administrators;
    select_counters;

*/



    current_panel = main_menu;

    try {
      jbInit();


      looks = UIManager.getInstalledLookAndFeels();
      JMenuItem look_and_feel;
      for (int i=0; i<looks.length; i++){
        look_and_feel = new JMenuItem();
        look_and_feel.setText(looks[i].getName());
        look_and_feel.setActionCommand(looks[i].getName());
        look_and_feel.addActionListener(new
                                        FrameCommissioner_look_and_feel_actionAdapter(this));
        jMenuLook.add(look_and_feel);
      }
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public void releaseMemory(){
    voter_administration.releaseMemory();
    group_administration.releaseMemory();
    select_voters.releaseMemory();

    election_administration.releaseMemory();
    configuration_administration.releaseMemory();
    server_administration.releaseMemory();
    configuration_selection.releaseMemory();

    System.gc();

  }



  public void newMessage(String msg){
    this.message.append("\n" + msg);
  }

  public void newMessageSameline(String msg){
   this.message.append(msg);
 }


  public void newErrorMessage(String msg){
    JOptionPane.showMessageDialog(this, msg, "Error", JOptionPane.ERROR_MESSAGE);
    this.message.append("\n" + msg);
  }

  public void newDialogWarningMessage(String title, String msg){
    JOptionPane.showMessageDialog(this, msg, title, JOptionPane.WARNING_MESSAGE);
  }

  public boolean newYesNoQuestionWarningDialog(String title, String msg){
    JTextArea text = new JTextArea();
    text.setEditable(false);
    text.setBackground(SystemColor.control);
    text.setText(msg);
    int option = JOptionPane.showConfirmDialog(this, text, title,  JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
    if (option==0)
      return true;
    return false;
   }

   public String newInputDialog(String title, String msg) {
     return JOptionPane.showInputDialog(this, msg, title,
                                        JOptionPane.PLAIN_MESSAGE);
   }

   public String fileDialog(String title, int mode) {
     FileDialog f = new FileDialog(this, title,
                                   (mode == FileDialog.LOAD ? FileDialog.LOAD : FileDialog.SAVE));
     f.show();
     String file = f.getDirectory() + f.getFile();
     if((f.getDirectory() != null) && (f.getFile() != null))
       return file;
     return null;
   }




  void jbInit() throws Exception {
    this.setDefaultCloseOperation(EXIT_ON_CLOSE);
    this.setLocale(java.util.Locale.getDefault());
    this.setJMenuBar(jMenuBar1);
    this.setResizable(false);
    this.setTitle("Commissioner");
    this.getContentPane().setLayout(borderLayout1);
    message.setEnabled(true);
    message.setForeground(Color.black);
    message.setBorder(BorderFactory.createEtchedBorder());
    message.setDoubleBuffered(false);
    message.setCaretPosition(0);
    message.setEditable(false);
    message.setLineWrap(true);
    message.setRows(5);
    borderLayout1.setVgap(5);

    jLabel1.setFont(new java.awt.Font("Dialog", 0, 20));
    jLabel1.setForeground(Color.blue);
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel1.setText("Commissioner Console");
    jMenuView.setText("View");
    jMenuLook.setActionCommand("Look And Feel");
    jMenuLook.setText("Look And Feel");
    jMenuItem1.setText("Exit");
    jMenuFile.setText("File");
    jMenuItemExit.setText("Exit");
    jMenuItemExit.addActionListener(new FrameCommissioner_jMenuItemExit_actionAdapter(this));
    this.getContentPane().add(current_panel, BorderLayout.CENTER);
    this.getContentPane().add(jScrollPaneMessage, BorderLayout.SOUTH);
    this.getContentPane().add(jLabel1, BorderLayout.NORTH);
    jScrollPaneMessage.getViewport().add(message, null);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuView);
    jMenuView.add(jMenuLook);
    jMenuFile.add(jMenuItemExit);

  }


  public static void start(Commissioner commi) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    FrameCommissioner frameCommissioner = (commi == null)?
        new FrameCommissioner():
        new FrameCommissioner(commi);

    frameCommissioner.pack();


//Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frameCommissioner.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frameCommissioner.setLocation( (screenSize.width - frameSize.width) / 2,
                                  (screenSize.height - frameSize.height) / 2);
    frameCommissioner.setVisible(true);

  }


  public static void main(String[] args) {
    start(null);
  }

  private void setPanel(JPanel panel){
    current_panel.setVisible(false);
    this.getContentPane().remove(current_panel);
    current_panel=panel;
    this.getContentPane().add(panel, BorderLayout.CENTER);
    current_panel.setVisible(true);
  }

  public void setMainMenu(){
    this.releaseMemory();
    this.setPanel(main_menu);
  }

  public void setUtilities(Vector administrators){
    this.utilities.setAdministrators(administrators);
    this.setPanel(utilities);
  }

  /*
   * Create voters passwords
   */
  public void setCreateVotersPasswords(){
    this.create_voters_passwords =
        new CreateVotersPasswords(this, "Create Voters' Passwords", true, this.commi);
    this.create_voters_passwords.show();
  }

  public void disposeCreateVotersPasswords(){
    this.create_voters_passwords.dispose();
  }

  public boolean passwordPin(){
    return this.create_voters_passwords.passwordPin();
  }

  public boolean allVoters(){
    return this.create_voters_passwords.allVoters();
  }

  /*
   * Voter's Administration
   */


  public void setVotersAdministration(Vector voters){
    this.setVotersList(voters);
    this.setVotersAdministration();
  }

  public void setVotersAdministration(){
    this.setPanel(this.voter_administration);
  }


  public void setVotersList(Vector voters){
    this.voter_administration.updateList(voters);
  }

  public byte getVotersAdministrationState(){
    return this.voter_administration.getState();
  }

  public IdDescription getActiveVoter(){
    return this.voter_administration.getVoter();
  }

  /*
   * Voter's Passwords
   */

  public void setVoterPassword(){
    this.voter_password = new VoterPassword(this.commi, this, "Password", true);
    this.voter_password.show();
  }

  public char[][] getPasswordPin(){
    return this.voter_password.getPasswordPIN();
  }

  public char[][] getConfirmedPasswordPin(){
    return this.voter_password.getConfirmedPasswordPIN();
  }

  public void setPasswordPin(char[][] password_pin){
    this.voter_password.setPasswordPin(password_pin);
  }

  public void clearPasswordPin(){
    this.voter_password.clearPasswords();
  }

  public void disposeVoterPassword(){
    this.voter_password.dispose();
  }


  /*
   * Group's Administration
   */

  public void setGroupAdministration(Vector groups){
    this.setGroupList(groups);
    this.setPanel(this.group_administration);
  }

  public void setGroupAdministration(){
    this.setPanel(this.group_administration);
  }


  public void setGroupList(Vector groups){
    this.group_administration.updateList(groups);
  }

  public IdDescription getActiveGroup(){
    return this.group_administration.getGroup();
  }

  public byte getGroupAdministrationState(){
      return this.group_administration.getState();
    }


    /*
     * Voter Selection
     */

  public void setSelectVoters(String name, Voters2Group group_voters, Vector all_voters){
    this.select_voters.init(name, group_voters, all_voters);
    this.setPanel(this.select_voters);
  }

  public Voters2Group getGroupVoters(){
    return this.select_voters.getGroupVoters();
  }


  /*
   * Election Administration
   */


  public void setElectionAdministration(Vector elections, Vector groups, Vector configurations){
    this.election_administration.init(elections, groups, configurations);
    this.setPanel(this.election_administration);
  }

  public void setElectionsAdministration(){
    this.setPanel(this.election_administration);
  }


  public void setElectionList(Vector elections){
    this.election_administration.updateList(elections);
  }

  public Election getActiveElection(){
    return this.election_administration.getElection();
  }

  public byte getElectionAdministrationState(){
      return this.election_administration.getState();
    }


  /*
  * Configuration Administration CA
  */

  public void setConfigurationAdministration(Vector configurations) {
    this.setConfigurationList(configurations);
    this.setPanel(this.configuration_administration);
  }

   public void setConfigurationAdministration(){
     this.setPanel(this.configuration_administration);
   }

   public void setConfigurationList(Vector configurations){
     this.configuration_administration.updateList(configurations);
   }

   public Configuration getActiveConfiguration(){
     return this.configuration_administration.getConfiguration();
   }

   public byte getConfigurationAdministrationState(){
       return this.configuration_administration.getState();
     }






     /*
      * Server Administration SA
      */

  public void setServerAdministration(Vector distributors,
                                      Vector administrators,
                                      Vector anonymizers, Vector counters) {
    this.setServersList(distributors, administrators, anonymizers, counters);
    this.setPanel(this.server_administration);
  }

  public void setServersList(Vector distributors, Vector administrators,
                             Vector anonymizers, Vector counters) {
    this.server_administration.updateLists(distributors, administrators,
                                           anonymizers, counters);
  }

  public void setDistributorsList(Vector distributors) {
    this.server_administration.updateDistributorsList(distributors);
  }

  public void setAdministratorsList(Vector administrators) {
    this.server_administration.updateAdministratorsList(administrators);
  }

  public void setAnonymizersList(Vector anonymizers) {
    this.server_administration.updateAnonymizersList(anonymizers);
  }

  public void setCountersList(Vector counters) {
    this.server_administration.updateCountersList(counters);
  }

  public byte getServertype() {
    return this.server_administration.getTypeOfServer();
  }

  public Server getActiveServer() {
    return this.server_administration.getServer();
  }

     /*
      * Configuration Selection
      */

  public void setConfigurationSelection(Vector configurations) {
    this.setConfigurationSelectionList(configurations);
    this.setConfigurationSelection();
  }

  public void setConfigurationSelection() {
    this.setPanel(this.configuration_selection);
  }

  public void setConfigurationSelectionList(Vector configurations) {
    this.configuration_selection.updateList(configurations);
  }

  public Configuration getSelectedConfiguration() {
    return this.configuration_selection.getConfiguration();
  }

  public boolean generateElectionKeys() {
    return this.configuration_selection.generateElectionKeys();
  }

  public boolean generateAdministratorsSigningKeys() {
    return this.configuration_selection.generateAdministratorsSigningKeys();
  }

  public void showKeys(boolean option){
    this.configuration_selection.showKeys(option);
  }


  /*
   *  Utilities
   */

  public int getSelectedAdministrator(){
    return this.utilities.getAdministrator();
  }

  void look_and_feel_actionPerformed(ActionEvent e) {
    for(int i=0; i<looks.length; i++){
      try {
        if (looks[i].getName().equals(e.getActionCommand())) {
          UIManager.setLookAndFeel(looks[i].getClassName());
          SwingUtilities.updateComponentTreeUI(this);
          this.pack();
          break;
        }
      }
      catch (Exception ex) {
        ex.printStackTrace();
      }
    }
  }

  void jMenuItemExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }







}

class FrameCommissioner_look_and_feel_actionAdapter implements java.awt.event.ActionListener {
  FrameCommissioner adaptee;

  FrameCommissioner_look_and_feel_actionAdapter(FrameCommissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.look_and_feel_actionPerformed(e);
  }
}



class FrameCommissioner_jMenuItemExit_actionAdapter implements java.awt.event.ActionListener {
  FrameCommissioner adaptee;

  FrameCommissioner_jMenuItemExit_actionAdapter(FrameCommissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItemExit_actionPerformed(e);
  }
}






























