package inescID.revs.commissioner;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class MainMenu extends JPanel {
  JButton MMvoters = new JButton();
  JButton MMconfiguration = new JButton();
  JButton MMservers = new JButton();
  JButton MMelections = new JButton();
  JButton MMcreate_databases = new JButton();
  JButton MMUtilities = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();


  public MainMenu(Commissioner commi){
    this.start();
    this.setActionListener(commi);
  }

  public MainMenu() {
    this.start();
  }

  public void start() {
      try {
        jbInit();
      }
      catch(Exception ex) {
        ex.printStackTrace();
      }
    }

  void jbInit() throws Exception {
    MMUtilities.setFont(new java.awt.Font("Dialog", 0, 14));
    MMUtilities.setMaximumSize(new Dimension(50, 27));
    MMUtilities.setMinimumSize(new Dimension(50, 27));
    MMUtilities.setPreferredSize(new Dimension(300, 50));
    MMUtilities.setText("Utilities");
    MMcreate_databases.setFont(new java.awt.Font("Dialog", 0, 14));
    MMcreate_databases.setMaximumSize(new Dimension(50, 27));
    MMcreate_databases.setMinimumSize(new Dimension(50, 27));
    MMcreate_databases.setPreferredSize(new Dimension(300, 50));
    MMcreate_databases.setText("Create Election Data");
    MMelections.setFont(new java.awt.Font("Dialog", 0, 14));
    MMelections.setMaximumSize(new Dimension(50, 27));
    MMelections.setMinimumSize(new Dimension(50, 27));
    MMelections.setPreferredSize(new Dimension(200, 50));
    MMelections.setText("Elections");
    MMservers.setFont(new java.awt.Font("Dialog", 0, 14));
    MMservers.setMaximumSize(new Dimension(50, 27));
    MMservers.setMinimumSize(new Dimension(50, 27));
    MMservers.setPreferredSize(new Dimension(200, 50));
    MMservers.setText("Servers");
    MMconfiguration.setFont(new java.awt.Font("Dialog", 0, 14));
    MMconfiguration.setMaximumSize(new Dimension(50, 27));
    MMconfiguration.setMinimumSize(new Dimension(50, 27));
    MMconfiguration.setPreferredSize(new Dimension(200, 50));
    MMconfiguration.setText("Configurations");
    MMvoters.setFont(new java.awt.Font("Dialog", 0, 14));
    MMvoters.setMaximumSize(new Dimension(50, 27));
    MMvoters.setMinimumSize(new Dimension(50, 27));
    MMvoters.setPreferredSize(new Dimension(200, 50));
    MMvoters.setText("Voters");
    this.setLayout(gridBagLayout1);
    this.setEnabled(true);
    this.setBorder(BorderFactory.createEtchedBorder());
    this.setMinimumSize(new Dimension(600, 480));
    this.setPreferredSize(new Dimension(600, 480));
    this.add(MMcreate_databases,    new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 5, 0), 0, 0));
    this.add(MMservers, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 10, 5, 5), 0, 0));
    this.add(MMvoters, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 10, 5, 5), 0, 0));
    this.add(MMelections, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 5, 5, 10), 0, 0));
    this.add(MMconfiguration, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 10), 0, 0));
    this.add(MMUtilities,   new GridBagConstraints(0, 3, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 10, 0), 0, 0));
  }

  public void setActionListener(Commissioner commi) {
    MMvoters.addActionListener(new MainMenu_voters_actionAdapter(commi));
    MMconfiguration.addActionListener(new MainMenu_configuration_actionAdapter(commi));
    MMservers.addActionListener(new MainMenu_servers_actionAdapter(commi));
    MMelections.addActionListener(new MainMenu_elections_actionAdapter(commi));
    MMcreate_databases.addActionListener(new MainMenu_create_databases_actionAdapter(commi));
    MMUtilities.addActionListener(new MainMenu_import_data_actionAdapter(commi));
  }

}

class MainMenu_voters_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  MainMenu_voters_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.MMvoters_actionPerformed(e);
  }
}

class MainMenu_elections_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  MainMenu_elections_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.MMelections_actionPerformed(e);
  }
}

class MainMenu_servers_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  MainMenu_servers_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.MMservers_actionPerformed(e);
  }
}

class MainMenu_configuration_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  MainMenu_configuration_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.MMconfiguration_actionPerformed(e);
  }
}

class MainMenu_create_databases_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  MainMenu_create_databases_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.MMcreate_distribution_files_actionPerformed(e);
  }
}

class MainMenu_import_data_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  MainMenu_import_data_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.MMutilities_actionPerformed(e);
  }
}
