package inescID.revs.commissioner;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.revs.util.Server;

public class Utilities extends JPanel {
  JButton create_passwords = new JButton();
  JButton import_voters = new JButton();
  JButton import_elections = new JButton();
  JButton import_adm_sig_keys = new JButton();
  JButton export_elections = new JButton();
  JPanel jPanel1 = new JPanel();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel jLabel1 = new JLabel();
  JButton import_groups = new JButton();
  JButton back = new JButton();
  JComboBox administrator = new JComboBox();
  JPanel jPanel2 = new JPanel();
  VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();


  Vector administrators;


  public Utilities() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public Utilities(Commissioner commi) {
   try {
     jbInit();
     this.setActionListener(commi);
   }
   catch(Exception ex) {
     ex.printStackTrace();
   }
 }


  void jbInit() throws Exception {
    create_passwords.setSelected(false);
    create_passwords.setText("Create Voters\' Passwords");
    import_voters.setText("Import Voters");
    import_elections.setActionCommand("Import_Elections");
    import_elections.setText("Import Elections");
    import_adm_sig_keys.setText("Import Administrators Signing Keys");
    export_elections.setText("Export Elections");
    jPanel1.setLayout(gridBagLayout2);
    this.setLayout(borderLayout1);
    jLabel1.setFont(new java.awt.Font("Dialog", 0, 18));
    jLabel1.setMaximumSize(new Dimension(58, 35));
    jLabel1.setMinimumSize(new Dimension(58, 35));
    jLabel1.setPreferredSize(new Dimension(58, 35));
    jLabel1.setToolTipText("");
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel1.setText("Utilities");
    import_groups.setText("Import Voters Groups");
    back.setSelectedIcon(null);
    back.setText("back");
    jPanel2.setLayout(verticalFlowLayout1);
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.add(create_passwords,                     new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 0, 5, 0), 0, 0));
    jPanel1.add(export_elections,                       new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 0, 5, 0), 0, 0));
    jPanel1.add(import_elections,                     new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 0, 5, 0), 0, 0));
    jPanel1.add(import_voters,              new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 0, 5, 0), 0, 0));
    jPanel1.add(import_groups,    new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 0, 5, 0), 0, 0));
    jPanel1.add(back,    new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jPanel2,   new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(import_adm_sig_keys, null);
    jPanel2.add(administrator, null);
    this.add(jLabel1, BorderLayout.NORTH);
    this.add(jPanel1, BorderLayout.CENTER);
  }




  void setActionListener(Commissioner commi){
    create_passwords.addActionListener(new
                                       Utilities_create_passwords_actionAdapter(commi));
    import_voters.addActionListener(new Utilities_import_voters_actionAdapter(commi));
    import_elections.addActionListener(new
                                       Utilities_import_elections_actionAdapter(commi));
    import_groups.addActionListener(new Utilities_import_groups_actionAdapter(commi));
    import_adm_sig_keys.addActionListener(new Utilities_import_adm_sig_keys_actionAdapter(commi));
    export_elections.addActionListener(new Utilities_export_elections_actionAdapter(commi));
    back.addActionListener(new Utilities_back_actionAdapter(commi));
 }




 public void setAdministrators(Vector administrators){
   this.administrators = administrators;
   Server adm;
   this.administrator.removeAllItems();
   for(int i=0; i < this.administrators.size(); i++){
     adm = (Server) this.administrators.get(i);
     this.administrator.addItem(adm.GetDescription());
   }
 }

 public int getAdministrator(){
  String adm = (String) this.administrator.getSelectedItem();
  Server aux;

  for(int i=0; i < this.administrators.size(); i++){
    aux = (Server) this.administrators.get(i);
    if (adm.equals(aux.GetDescription()))
      return aux.GetId();
  }
  return -1;
 }

}
class Utilities_create_passwords_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  Utilities_create_passwords_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.UTcreate_passwords_actionPerformed(e);
  }
}

class Utilities_import_voters_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  Utilities_import_voters_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.UTimport_voters_actionPerformed(e);
  }
}

class Utilities_import_groups_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  Utilities_import_groups_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.UTimport_groups_actionPerformed(e);
  }
}

class Utilities_import_elections_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  Utilities_import_elections_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.UTimport_elections_actionPerformed(e);
  }
}

class Utilities_export_elections_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  Utilities_export_elections_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.UTexport_elections_actionPerformed(e);
  }
}

class Utilities_import_adm_sig_keys_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  Utilities_import_adm_sig_keys_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.UTimport_adm_sig_keys_actionPerformed(e);
  }
}

class Utilities_back_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  Utilities_back_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.UTback_actionPerformed(e);
  }
}
