package inescID.revs.database;

import java.sql.*;

/**
 * <p>Title: revs</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class CommonDatabase {

  protected final String driver = "com.mysql.jdbc.Driver";
  protected final String preURL = "jdbc:mysql:";
  protected String url;
  protected String user;
  protected String password;
  protected Connection con = null;
  protected Clock clock;

  protected PreparedStatement preInsereControlo;

  public CommonDatabase(){
  }

  public void finalize() throws Throwable {
    if (con != null)
      con.close();
  }

  public void DBInit(String db, String user, String password)
      throws java.lang.ClassNotFoundException, SQLException {

    Class.forName(this.driver);
    this.url = preURL + db;
    this.user = user;
    this.password = password;
    this.connectDB();
    this.createPingTable();
    this.clock = new Clock(this);
    this.clock.start();

  }

  public void connectDB() throws SQLException{
    this.con = DriverManager.getConnection(this.url, this.user, this.password);
  }

  public void createPingTable() throws SQLException{
    String tabela = "DROP TABLE IF EXISTS ping";
    Statement stmt = this.con.createStatement();
    stmt.executeUpdate(tabela);

    tabela = "CREATE TABLE ping (" +
                "Id int(10) NOT NULL auto_increment," +
                "Date bigint NOT NULL default '0'," +
                "PRIMARY KEY  (Id));";
    stmt = this.con.createStatement();
    stmt.executeUpdate(tabela);

    this.preInsereControlo = this.con.prepareStatement(
        "INSERT INTO ping (Date) VALUES (?)");
  }

public void createTables() {
  createTables(new String());
}

 public void createTables(String error) {
   if(error.length() != 0){
     System.err.println("Error creating tables: " + error);
   }
 }

 public void removeTables() {
   removeTables(new String());
 }

 public void removeTables(String error) {
   if(error.length() != 0){
     System.err.println("Error removing tables: " + error);
   }
 }


 public void redoTables() {
   removeTables(new String());
   createTables(new String());
 }

  public void verify() {
    try {
      this.preInsereControlo.setLong(1, System.currentTimeMillis());
      this.preInsereControlo.executeUpdate();
      //System.err.println("BD - OK");
    }
    catch (SQLException ex) {
      /**@todo mail to commissioner */
     System.err.println("BD - ERROR");
    }
  }

}
