package inescID.revs.displayBallot;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import javax.swing.text.*;

public class LimitDocument extends PlainDocument
{
    private int limit;

    public LimitDocument(int limit)
    {
        super();
     setLimit(limit); // store the limit
    }

    public final int getLimit()
    {
     return limit;
    }

    public void insertString(int offset, String s, AttributeSet attributeSet) throws
        BadLocationException {
      int end = getEndPosition().getOffset() - 1; // get the position of where the string ends

      StringBuffer sb = new StringBuffer(getText(0, end));
      sb = sb.insert(offset, s);

      String new_s = sb.toString();
      if (new_s.length() >= limit) {
        new_s = new_s.substring(0, limit);
      }

      super.remove(0, end);
      super.insertString(0, new_s, attributeSet);
    }

    public final void setLimit(int newValue) {
      this.limit = newValue;
    }
}

/*
public static void main(String args[])
{
    JFrame f = new JFrame("Limit Test");

    JTextField text = new JTextField();
    text.setDocument(new LimitDocument(10));

    f.getContentPane().add(BorderLayout.NORTH,text);
    f.pack();
    f.show();
}
*/
