package inescID.revs.displayBallot;

import java.awt.*;
import javax.swing.*;
import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.revs.xml.*;
import com.borland.jbcl.layout.*;
import javax.swing.border.*;
import java.io.*;
import java.beans.*;
import java.awt.event.*;

public class PanelBallot extends JPanel implements IBallotViewer{
  BorderLayout borderLayout1 = new BorderLayout();
  JTextArea description = new JTextArea();
 JScrollPane jScrollGroups = new JScrollPane();
  JPanel groups_panel = new JPanel();
  VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();

  ParsedBallot ballot;
  PanelGroup[] panel_groups;
  TitledBorder titledBorder1;
  JPanel jPanel1 = new JPanel();
  VerticalFlowLayout verticalFlowLayout2 = new VerticalFlowLayout();
  JLabel election_description = new JLabel();
  JScrollPane jScrollPane_aux = new JScrollPane();

  public PanelBallot() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    this.setLayout(borderLayout1);
    description.setBackground(new Color(255, 255, 170));
    description.setFont(new java.awt.Font("Courier New", 0, 12));
    description.setBorder(titledBorder1);
    description.setEditable(false);
    description.setText("description");
    groups_panel.setLayout(verticalFlowLayout1);
    groups_panel.setBackground(new Color(50, 105, 200));
    groups_panel.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setLayout(verticalFlowLayout2);
    election_description.setFont(new java.awt.Font("Garamond", 1, 22));
    election_description.setBorder(titledBorder1);
    election_description.setDebugGraphicsOptions(0);
    election_description.setOpaque(true);
    election_description.setHorizontalAlignment(SwingConstants.CENTER);
    election_description.setHorizontalTextPosition(SwingConstants.CENTER);
    election_description.setText("election");
     verticalFlowLayout1.setHgap(10);
    verticalFlowLayout1.setVgap(10);
    this.add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(election_description, null);
    jPanel1.add(description, null);
    this.add(jScrollGroups,  BorderLayout.CENTER);
    jScrollGroups.getViewport().add(jScrollPane_aux, null);
  }

  public void setBallot(ParsedBallot ballot){
    groups_panel.removeAll();
    this.ballot = ballot;
    if (this.ballot.getDescription().size()>0){
      description.setText((String) this.ballot.getDescription().get(0));
      for (int i = 1; i < this.ballot.getDescription().size(); i++) {
        description.append("\n" + this.ballot.getDescription().get(i));
      }
    }

    Vector groups = this.ballot.getGroups();
    this.panel_groups = new PanelGroup[groups.size()];
    BallotGroup group;
    for (int i = 0; i < groups.size() ; i++) {
      group = (BallotGroup) groups.get(i);
      this.panel_groups[i] = new PanelGroup();
      this.panel_groups[i].setGroup(group);
      this.groups_panel.add(this.panel_groups[i]);
    }
   jScrollPane_aux.getViewport().add(groups_panel, null);
   jScrollGroups.getViewport().setViewPosition(new Point(0,0));

  }

  public void setElectionDescription(String description){
    this.election_description.setText(description);
  }


  public ParsedBallot getAnswers(){
    Vector answers = new Vector();
    for(int i=0; i<this.panel_groups.length; i++){
      answers.add(this.panel_groups[i].getAnswers());
    }
    this.ballot.setGroups(answers);
    return this.ballot;
  }

  public void setPortuguese() {
    for (int i = 0; i < this.panel_groups.length; i++)
      this.panel_groups[i].setPortuguese();
  }
}
