package inescID.revs.displayBallot;

import javax.swing.*;
import java.util.Vector;
import javax.swing.text.JTextComponent;
import java.awt.event.*;
import java.beans.*;
import javax.swing.event.*;
import com.borland.jbcl.layout.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.revs.xml.*;
import inescID.revs.REVSConfiguration;

public class PanelOpenMultipleOptions
    extends PanelMultipleOptions {
  JCheckBox other;
  JTextComponent text;

  public PanelOpenMultipleOptions() {

    VerticalFlowLayout verticalFlowLayout = new VerticalFlowLayout();
    this.setLayout(verticalFlowLayout);


   }

  public void setOptions(Vector options){
    if (options.size()==0){
      super.setOptions(options);
      other = new JCheckBox("Other");
      other.setSelected(true);
      JTextArea text = new JTextArea((REVSConfiguration.MAX_COMMENT_LENGTH/
                                     REVSConfiguration.MAX_STRING_LENGTH) + 1,
                                     REVSConfiguration.MAX_STRING_LENGTH);
      text.setDocument(new LimitDocument(REVSConfiguration.MAX_COMMENT_LENGTH));
      text.setLineWrap(true);
      text.setWrapStyleWord(true);
      this.text = text;
      this.add(this.text);
    }
    else{
      super.setOptions(options);
      other = new JCheckBox("Other");
      other.addActionListener(new PanelOpenMultipleOptions_other_actionAdapter(this));
      this.add(this.other);
      JTextField text = new JTextField();
      text.setDocument(new LimitDocument(REVSConfiguration.MAX_STRING_LENGTH));
      text.setEditable(false);
      this.text = text;
      this.add(this.text);
    }
  }

  /**
   * clear
   */
  void clear() {
    super.clear();
    this.text.setText("");
    this.other.setSelected(false);
  }

  /**
   * getAnswer
   */
  QuestionAnswer getAnswer() {
    QuestionAnswer answer = new QuestionAnswer();
    if (this.other.isSelected()){
      answer.setOpenAnswer(this.text.getText());
    }
    if (this.option_buttons==null)
      return answer;

    QuestionOption option;
    for(int i=0; i<this.option_buttons.length; i++){
      if (this.option_buttons[i].isSelected()){
        option = (QuestionOption) this.options.get(i);
        answer.addAnswer(option.getCode());
      }
    }
    return answer;
  }

  void other_actionPerformed(ActionEvent e) {
    this.text.setEditable(!this.text.isEditable());
    this.text.setText("");
  }

  void setPortuguese(){
    this.other.setText("Outro");
  }

}


class PanelOpenMultipleOptions_other_actionAdapter implements java.awt.event.ActionListener {
  PanelOpenMultipleOptions adaptee;

  PanelOpenMultipleOptions_other_actionAdapter(PanelOpenMultipleOptions adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.other_actionPerformed(e);
  }
}

