package inescID.revs.displayBallot;

import javax.swing.*;
import java.util.*;
import javax.swing.text.JTextComponent;
import java.awt.event.*;
import java.beans.*;
import javax.swing.event.*;
import com.borland.jbcl.layout.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.revs.xml.*;
import inescID.revs.REVSConfiguration;

public class PanelOpenSingleOptions extends PanelSingleOptions {
  JRadioButton other;
  JTextComponent text;

  public PanelOpenSingleOptions(){

    VerticalFlowLayout verticalFlowLayout = new VerticalFlowLayout();
    this.setLayout(verticalFlowLayout);


  }

  public void setOptions(Vector options){
    if (options.size()==0){
      super.setOptions(options);
      this.other = new JRadioButton("Other");
      JTextField text = new JTextField();
      text.setDocument(new LimitDocument(REVSConfiguration.MAX_STRING_LENGTH));
      this.text = text;
      this.add(this.text);
    }
    else{
      super.setOptions(options);
      this.other = new JRadioButton("Other");
      this.other.addActionListener(new PanelOpenSingleOptions_other_actionAdapter(this));
      Enumeration buttons = this.options_group.getElements();
      for(;buttons.hasMoreElements();){
        ((JRadioButton) buttons.nextElement()).
            addActionListener(new PanelOpenSingleOptions_clear_actionAdapter(this));
      }

      this.add(this.other);
      this.options_group.add(this.other);


      JTextField text = new JTextField();
      text.setDocument(new LimitDocument(REVSConfiguration.MAX_STRING_LENGTH));
      text.setEditable(false);
      this.text = text;
      this.add(this.text);
    }
   }

  /**
   * clear
   */
  void clear() {
    this.text.setText("");
    if(this.other!=null){
      this.options_group.setSelected(dummy.getModel(), true);
      this.text.setEditable(false);
    }
  }

  /**
   * getAnswer
   */
  QuestionAnswer getAnswer() {
    QuestionAnswer answer = new QuestionAnswer();

    if (this.dummy.isSelected())
      return answer;

    if (this.text.getText().length()!=0){
      answer.setOpenAnswer(this.text.getText());
      return answer;
    }

    QuestionOption option;
    for(int i=0; (this.option_buttons!=null) && (i<this.option_buttons.length); i++){
      if (this.option_buttons[i].isSelected()){
        option = (QuestionOption) this.options.get(i);
        answer.addAnswer(option.getCode());
        break;
      }
    }
    return answer;
  }

  void clear_actionPerformed(ActionEvent e) {
      this.text.setEditable(false);
      this.text.setText("");
    }


  void other_actionPerformed(ActionEvent e) {
    this.text.setEditable(true);
 //   this.text.setText("");
  }


  void setPortuguese(){
    this.other.setText("Outro");
  }


}

class PanelOpenSingleOptions_clear_actionAdapter implements java.awt.event.ActionListener {
  PanelOpenSingleOptions adaptee;

  PanelOpenSingleOptions_clear_actionAdapter(PanelOpenSingleOptions adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.clear_actionPerformed(e);
  }
}


class PanelOpenSingleOptions_other_actionAdapter implements java.awt.event.ActionListener {
  PanelOpenSingleOptions adaptee;

  PanelOpenSingleOptions_other_actionAdapter(PanelOpenSingleOptions adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.other_actionPerformed(e);
  }
}

