package inescID.revs.servers;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.util.FileTool;
import java.io.FileNotFoundException;
import java.io.IOException;

import inescID.revs.REVSConfiguration;
public class ReadConfigurationFile {


  final byte SERVER = 0;
  final byte DATABASE = 1;

  String[][] COMMANDS = {
      {"SERVER", ""},
      {"DATABASE", ""}
  };


  public ReadConfigurationFile() throws FileNotFoundException, IOException,
      FileNotFoundException, IOException, Exception, FileNotFoundException,
      IOException, Exception, Throwable {
    this.readConfiguration(REVSConfiguration.CONFIGURATION_FILE);
  }


  public ReadConfigurationFile(String file) throws FileNotFoundException,
      IOException, FileNotFoundException, IOException, Exception,
      FileNotFoundException, IOException, Exception, Throwable {
    this.readConfiguration(file);
  }

  public String getServerAddress(){
    return this.COMMANDS[SERVER][1];
  }

  public String getDatabaseAddress(){
    return this.COMMANDS[DATABASE][1];
  }




  private void readConfiguration(String file) throws FileNotFoundException,
      IOException, Exception, Throwable {
    FileTool ft = new FileTool();
    ft.initReadLine(file);

    String line = ft.readLine();
    String[] aux;
    int i=0;
    int line_number=0;
    while (line != null){
      line_number++;
      aux = line.split("\\s");

      //verify empty or comment line
      if((aux[0].length() > 0) && (! aux[0].startsWith("#"))) {
        for(i = 0; i < COMMANDS.length; i++) {
          if(aux[0].equals(COMMANDS[i][0]) && (aux.length == 2)) {
            COMMANDS[i][1] = aux[1];
            break;
          }
        }
        if ((i == COMMANDS.length)){
          throw new Exception("Error processing configuration file at line " + line_number);
        }
      }
      line = ft.readLine();
    }
    ft.closeReadFile();
  }



}
