package inescID.revs.util;

import java.util.Vector;
import java.security.Key;

/**
 * <p>Title: e-voto</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.crypto.KeyStoreTool;
import java.security.*;
import java.security.spec.InvalidKeySpecException;

public class Ballot implements java.io.Serializable {

  protected int election_id;
  protected String ballot;
  protected byte[] election_key;
  protected int required_signatures;
  protected AdministratorElectionAddress[] administrators;
  protected Vector submit_servers; //Server

  public Ballot(int election, String ballot, Key key, int req_signatures,
                AdministratorElectionAddress[] administrators, Vector submit_servers) {
    this.election_id = election;
    this.ballot = ballot;
    this.election_key = key.getEncoded();
    this.required_signatures = req_signatures;
    this.administrators = administrators;
    this.submit_servers = submit_servers;
  }

  public int getElection () {
    return this.election_id;
  }

  public String getBallot () {
   return this.ballot;
  }

  public Key getElectionKey ()  {
    try {
      KeyStoreTool kst = new KeyStoreTool();
      return kst.getRSAPublicKey(this.election_key);
    }
    catch (InvalidKeySpecException ex) {
      return null;
    }
    catch (NoSuchAlgorithmException ex) {
      return null;
    }
  }

  public int getRequiredSignatures () {
   return this.required_signatures;
  }

  public AdministratorElectionAddress[] getAdministrators () {
    return this.administrators;
  }

  public Vector getSubmitServers () {
    return this.submit_servers;
  }

}
