package inescID.revs.util;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */



import inescID.crypto.KeyStoreTool;
import java.security.*;
import java.security.spec.InvalidKeySpecException;


public class Election extends IdDescription implements java.io.Serializable {

  int id_voters_group;
  int id_configuration;
  byte[] key = null;
  String ballot;

  public Election() {
  }

  public Election(int Id_Election, String Description,
                  int Id_VotersGroup, int Id_Configuration,
                  Key key, String Ballot){
    super(Id_Election, Description);
    this.SetIdVotersGroup(Id_VotersGroup);
    this.SetConfiguration(Id_Configuration);
    this.SetKey(key);
    this.SetBallot(Ballot);
  }

  public Election(int Id_Election, String Description,
                  int Id_VotersGroup, int Id_Configuration,
                  byte[] key, String Ballot){
    super(Id_Election, Description);
    this.SetIdVotersGroup(Id_VotersGroup);
    this.SetConfiguration(Id_Configuration);
    this.SetKey(key);
    this.SetBallot(Ballot);
  }

  public Election(int Id_Election, String Description,
                  int Id_VotersGroup, int Id_Configuration) {
    super(Id_Election, Description);
    this.SetIdVotersGroup(Id_VotersGroup);
    this.SetConfiguration(Id_Configuration);
    this.key = null;
    this.ballot = null;
  }



  public void SetConfiguration(int Id_Configuration){
     this.id_configuration = Id_Configuration;
   }

   public int GetIdConfiguration(){
     return this.id_configuration;
  }

  public void SetIdVotersGroup(int Id_VotersGroup){
     this.id_voters_group = Id_VotersGroup;
   }

   public int GetIdVotersGroup(){
     return this.id_voters_group;
  }

  public void SetKey(Key key){
    this.key = key.getEncoded();
  }

  public void SetKey(byte[] key){
    this.key = key;
  }


  public Key GetPublicKey(){
    try {
      KeyStoreTool kst = new KeyStoreTool();
      return kst.getRSAPublicKey(this.key);
    }
    catch (InvalidKeySpecException ex) {
      return null;
    }
    catch (NoSuchAlgorithmException ex) {
      return null;
    }
  }

  public Key GetPrivateKey(){
    try {
     KeyStoreTool kst = new KeyStoreTool();
     return kst.getRSAPrivateKey(this.key);
   }
   catch (InvalidKeySpecException ex) {
     return null;
   }
   catch (NoSuchAlgorithmException ex) {
     return null;
   }

  }

  public byte[] GetKey(){
    return this.key;
  }


  public void SetBallot(String Ballot) {
    this.ballot = Ballot;
  }

  public String GetBallot() {
    return this.ballot;
  }

}
