package inescID.revs.util.protocol;

/**
 * <p>Title: CodigoErro</p>
 * <p>Description: Classe que contm os cdigos de erro da resposta</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */
public class ErrorCodes implements java.io.Serializable {
  public static final byte OK = 0;
  public static final byte ERROR = 1;
  public static final byte ERROR_TIME = 2;
  public static final byte ERROR_AUTHENTICATION = 3;
  public static final byte PREVIOUS_SIGNATURE = 4;
  public static final byte SIGNING_ERROR = 5;
  public static final byte VOTER_NOT_IN_ELECTION = 6;


  public static final String[] ERROR_DESCRIPTION = {
    "OK.",
    "Error.",
    "Error: out of election period.",
    "Authentication error.",
    "Previous signature.",
    "Signing error.",
    "Voter is not enable to vote in election."
    };

  public ErrorCodes(){}

}
