package inescID.revs.voter;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.beans.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class PanelAuthentication extends JPanel {
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel lauthentication = new JLabel();
  JLabel lvoter = new JLabel();
  JLabel lpassword = new JLabel();
  JLabel lpin = new JLabel();
  JTextField voter = new JTextField();
  JPasswordField password = new JPasswordField();
  JPasswordField pin = new JPasswordField();
  JCheckBox single_password = new JCheckBox();

  public PanelAuthentication() {
    try {
      jbInit();
      this.single_password_actionPerformed(null);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    lauthentication.setFont(new java.awt.Font("Garamond", 1, 16));
    lauthentication.setText("Authentication");
    this.setLayout(gridBagLayout1);
    lvoter.setRequestFocusEnabled(true);
    lvoter.setText("Id number:");
    lpassword.setText("Password:");
    lpin.setText("PIN:");
    voter.setMinimumSize(new Dimension(11, 22));
    voter.setPreferredSize(new Dimension(62, 22));
    voter.setText("");
    voter.setColumns(15);
    password.setText("");
    pin.setText("");
    single_password.setSelected(false);
    single_password.setText("Single password");
    single_password.addActionListener(new PanelAuthentication_single_password_actionAdapter(this));
    this.add(lauthentication,    new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 20, 0), 0, 0));
    this.add(lvoter,   new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 10), 0, 0));
    this.add(lpassword,    new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 0, 5, 10), 0, 0));
    this.add(lpin,   new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 10), 0, 0));
    this.add(voter,   new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    this.add(password,    new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(10, 0, 2, 0), 0, 0));
    this.add(pin,   new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    this.add(single_password,     new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 0, 0));
  }


  public String getVoter(){
    String voter = this.voter.getText();
    this.voter.setText("");
    return voter;
  }

  public char[][] getPasswords(){
    char[][] passwords = new char[2][];
    passwords[0] = this.password.getPassword();
    passwords[1] = (this.single_password.isSelected() ? null : this.pin.getPassword());
    this.password.setText("");
    this.pin.setText("");
    return passwords;
  }

  public void setJustPasswords(){
    this.lvoter.setVisible(false);
    this.voter.setVisible(false);
 }



  void single_password_actionPerformed(ActionEvent e) {
    if (this.single_password.isSelected()){
      this.pin.setVisible(false);
      this.lpin.setVisible(false);
    }
    else{
      this.pin.setText("");
      this.pin.setVisible(true);
      this.lpin.setVisible(true);
    }
  }


}


class PanelAuthentication_single_password_actionAdapter implements java.awt.event.ActionListener {
  PanelAuthentication adaptee;

  PanelAuthentication_single_password_actionAdapter(PanelAuthentication adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.single_password_actionPerformed(e);
  }
}
