package inescID.util;

import java.io.*;
import java.nio.channels.FileChannel;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class FileTool {
  LineNumberReader open_file = null;
  FileWriter append_file = null;

  public FileTool() {
  }


  public void writeObject2File(String file_name, Object obj) throws
      FileNotFoundException, IOException {
    FileOutputStream file = new FileOutputStream(file_name);
    ObjectOutputStream objOut = new ObjectOutputStream(file);
    objOut.writeObject(obj);
    objOut.flush();
    objOut.close();
  }

  public Object readObjectFromFile(String file_name) throws
      FileNotFoundException, ClassNotFoundException, IOException {
    FileInputStream file = new FileInputStream(file_name);
    ObjectInputStream objIn = new ObjectInputStream(file);
    Object obj = objIn.readObject();
    file.close();
    return obj;
  }

  public String readTextFile(String file_name) throws
      FileNotFoundException, IOException {
     String file_text = new String();
     String line;
     FileReader file = new FileReader(file_name);
     LineNumberReader line_reader = new LineNumberReader(file);
     line = line_reader.readLine();
     while(line != null) {
       file_text += line + "\n";
       line = line_reader.readLine();
     }
     return file_text;
   }


   public void initReadLine(String file_name) throws
       FileNotFoundException, IOException {
      FileReader file = new FileReader(file_name);
      if (this.open_file != null)
        this.open_file.close();
      this.open_file = new LineNumberReader(file);
    }



   public String readLine() throws
       FileNotFoundException, IOException {
     String line = null;
     if (this.open_file != null)
       line = this.open_file.readLine();
     return line;
    }

    public void initWrite(String file_name) throws
        FileNotFoundException, IOException {
      FileWriter file = new FileWriter(file_name, true);
      if (this.open_file != null)
        this.open_file.close();
      this.append_file = file;
    }

    public void writeLine(String line) throws IOException {
      line += "\n";
      this.append_file.write(line);
      this.append_file.flush();
    }


    public void write(String str) throws IOException {
      this.append_file.write(str);
    }


    public void closeReadFile() throws Throwable {
      if (this.open_file != null)
        this.open_file.close();
    }

    public void closeWriteFile() throws Throwable {
      if (this.append_file != null)
        this.append_file.close();
    }

    public void finalize() throws Throwable {
      if (this.open_file != null)
        this.open_file.close();
      if (this.append_file != null)
        this.append_file.close();

    }

    /** Fast & simple file copy. */
    public static void copy(String source, String dest) throws IOException {

      // Create channel on the source
        FileChannel srcChannel = new FileInputStream(source).getChannel();

        // Create channel on the destination
        FileChannel dstChannel = new FileOutputStream(dest).getChannel();

        // Copy file contents from source to destination
        dstChannel.transferFrom(srcChannel, 0, srcChannel.size());

        // Close the channels
        srcChannel.close();
        dstChannel.close();
    }



  }

