package inescID.util;

import java.io.*;
import java.net.PasswordAuthentication;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class InputTool {
  BufferedReader input;

  public InputTool() {
    input = new BufferedReader(new InputStreamReader(System.in));
  }

  public InputTool(InputStream in) {
      input = new BufferedReader(new InputStreamReader(in));
  }

  public String readLine(String msg) throws Exception {
    String buf;
    System.out.print(msg);
    System.out.flush();
    buf = input.readLine();
    return buf;
  }

  public char[] readPassword(String msg) throws Exception {
    if (msg != null)
      System.out.println("\n" + msg);
    return this.readLine("password: ").toCharArray();
  }

  public PasswordAuthentication readUserPassword(String msg, boolean defaults) throws Exception {
    System.out.println("\n" + msg);
    if (defaults)
      System.out.println("Press Enter for defaults.");
    String user = this.readLine("user: ");
    if (defaults && (user.length()==0))
      return null;
    char[] password = this.readPassword(null);

    return new PasswordAuthentication(user, password);
}


}

